;----------------------------------------------------------------------------------------------
;
; From Listing 7.5
;
; File Created 9/26/05
;
; * Vlad Pirogov *
; * The ASSEMBLY PROGRAMMING MASTER BOOK *
; * Modifications by Jeff C * Visit www.masmforum.com *
;----------------------------------------------------------------------------------------------

.586P
.MODEL FLAT, stdcall

; Constants
WM_DESTROY	equ	2
WM_CREATE	equ	1
WM_LBUTTONDOWN	equ	201h
WM_PAINT	equ	0Fh
CS_VREDRAW	equ	1h
CS_HREDRAW	equ	2h
CS_GLOBALCLASS	equ	4000h
WS_OVERLAPPEDWINDOW	equ	000CF0000h
stylcl		equ	CS_HREDRAW+CS_VREDRAW+CS_GLOBALCLASS
DX0		      equ	600 ; DX ZERO
DY0		      equ	400 ; DY ZERO
RGBW		      equ	(50 or (1 shl 8)) or (255 shl 16)
RGBR		      equ	0ff00ffh
RGBL		      equ	0
RGBP		      equ	255 or (100 shl 8)
IDI_APPLICATION	equ	32512
IDC_CROSS	      equ	32515
SW_SHOWNORMAL	equ	1
; Used in LoadImage() Function
IMAGE_BITMAP      equ 0

; Prototypes for External Prodecures
; WIN General API
EXTERN  CreateWindowExA@48:NEAR
EXTERN  DefWindowProcA@16:NEAR
EXTERN  DispatchMessageA@4:NEAR
EXTERN  ExitProcess@4:NEAR
EXTERN  GetMessageA@16:NEAR
EXTERN  GetModuleHandleA@4:NEAR
EXTERN  LoadCursorA@8:NEAR
EXTERN  LoadIconA@8:NEAR
EXTERN  PostQuitMessage@4:NEAR
EXTERN  RegisterClassA@4:NEAR
EXTERN  ShowWindow@8:NEAR
EXTERN  TranslateMessage@4:NEAR
EXTERN  UpdateWindow@4:NEAR
; WIN General API - GDI
EXTERN  BeginPaint@8:NEAR
EXTERN  EndPaint@8:NEAR
EXTERN  GetStockObject@4:NEAR
EXTERN  CreateSolidBrush@4:NEAR
EXTERN  GetSystemMetrics@4:NEAR
EXTERN  GetDC@4:NEAR
EXTERN  CreateCompatibleDC@4:NEAR
EXTERN  SelectObject@8:NEAR
EXTERN  CreateCompatibleBitmap@12:NEAR
EXTERN  PatBlt@24:NEAR
EXTERN  BitBlt@36:NEAR
EXTERN  ReleaseDC@8:NEAR
EXTERN  DeleteObject@4:NEAR
EXTERN  InvalidateRect@12:NEAR
EXTERN  GetStockObject@4:NEAR
EXTERN  DeleteDC@4:NEAR
EXTERN  CreatePen@12:NEAR
EXTERN  SetPixelV@16:NEAR
EXTERN  LineTo@12:NEAR
EXTERN  MoveToEx@16:NEAR
EXTERN  Rectangle@20:NEAR
EXTERN  Ellipse@20:NEAR
EXTERN  LoadImageA@24:NEAR
EXTERN  BitBlt@36:NEAR

; Structures
MSGSTRUCT	STRUC		; 6 DDs
	MSHWND	DD	?	; Identifier of the window
				; that received the message
	MSMESSAGE DD	?	; Message identifier
	MSWPARAM  DD	?	; Auxiliary information about the message
	MSLPARAM  DD	?	; Auxiliary information about the message
	MSTIME	DD	?	; Time of sending the message
	MSPT	DD	?	; Cursor position at the time of sending
				; the message
MSGSTRUCT	ENDS

WNDCLASS	STRUC			; 10 DDs
	CLSSTYLE	DD	?	; Window Style
	CLWNDPROC	DD	?	; Pointer to the window procedure
	CLSCBCCLSEX	DD	?	; 
	CLSCBWNDEX	DD	?	;
	CLSHINST	DD	?	;
	CLSHICON	DD	?	; Window icon descriptor
	CLSHCURSOR	DD	?	; Window cursor descriptor
	CLBKGROUND	DD	?	; Window brush descriptor
	CLMENNAME	DD	?	;
	CLNAME		DD	?	; Specifies the window class name
WNDCLASS	ENDS

PAINTSTR STRUC			; 8 DDs and 32 bytes buffer (Reserved)
	hdc	DD	0
	fErase	DD	0
	left	DD	0
	top	DD	0
	right	DD	0
	bottom	DD	0
	fRes	DD	0
	fIncUp	DD	0
	Reserv	DB 32 dup(0)
PAINTSTR ENDS

RECT STRUC			; 4 DDs
	L	DD	?	; LEFT
	T	DD	?	; TOP
	R	DD	?	; RIGHT
	B	DD	?	; BOTTOM
RECT ENDS

includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\gdi32.lib

;----------------------------------------------------------------------------------------------
; DATA SEGMENT
;----------------------------------------------------------------------------------------------
_DATA SEGMENT
	NEWHWND	DWORD		0
	MSG	MSGSTRUCT	<?>
	WC	WNDCLASS	<?>
	PNT	PAINTSTR	<?>
	HINST	DWORD		0
	TITLENAME	BYTE	'GRAPHICS IN A WINDOW (JEFF CUMMINGS 2005)', 0
	NAM	BYTE	'CLASS32', 0
	XT	DWORD	30
	YT	DWORD	30
	XM	DWORD	?
	YM	DWORD	?
	HDC	DWORD	?
	MEMDC	DWORD	?
	MEMDC2	DWORD	?
	HPEN	DWORD	?
	HBRUSH	DWORD	?
	P	DWORD	0	; OUTPUT INDICATOR
	XP	DWORD	?
	YP	DWORD	?
; USE IN BITMAP LOADING
      HBIT1 DWORD ?
      HAPPY BYTE  'HAPPY.BMP', 0
_DATA ENDS

;----------------------------------------------------------------------------------------------
; CODE SEGMENT
;----------------------------------------------------------------------------------------------
_TEXT SEGMENT
START:
	PUSH	0
	CALL	GetModuleHandleA@4
	MOV	[HINST], EAX
REG_CLASS:
	MOV	[WC.CLSSTYLE], stylcl
	MOV	[WC.CLWNDPROC], OFFSET WNDPROC
	MOV	[WC.CLSCBCCLSEX], 0
	MOV	[WC.CLSCBWNDEX], 0
	MOV	EAX, [HINST]
	MOV	[WC.CLSHINST], EAX
	PUSH	IDI_APPLICATION
	PUSH	0
	CALL	LoadIconA@8
	MOV	[WC.CLSHICON], EAX

	PUSH	IDC_CROSS
	PUSH	0
	CALL	LoadCursorA@8
	MOV	[WC.CLSHCURSOR], EAX

	PUSH	RGBW			; BRUSH COLOR blue background for window?
	CALL	CreateSolidBrush@4	; Create a Brush

	MOV	[WC.CLBKGROUND], EAX	; Window Color
	MOV	DWORD PTR [WC.CLMENNAME], 0
	MOV	DWORD PTR [WC.CLNAME], OFFSET NAM
	PUSH	OFFSET WC
	CALL	RegisterClassA@4

	PUSH	0
	PUSH	[HINST]
	PUSH	0
	PUSH	0
	PUSH	DY0			; DY - WINDOW HEIGHT
	PUSH	DX0			; DX - WINDOW WIDTH
	PUSH	100			; Y - COORDINATE OF THE WINDOW'S TOP LEFT CORNER
	PUSH	100			; X - COORDINATE OF THE WINDOW'S TOP LEFT CORNER
	PUSH	WS_OVERLAPPEDWINDOW
	PUSH	OFFSET TITLENAME	; WINDOW NAME
	PUSH	OFFSET NAM		; CLASS NAME
	PUSH	0
	CALL	CreateWindowExA@48

	CMP	EAX, 0
	JZ	_ERR
	MOV	[NEWHWND], EAX	; WINDOW DESCRIPTOR
	PUSH	SW_SHOWNORMAL
	PUSH	[NEWHWND]
	CALL	ShowWindow@8	; DISPLAY THE NEWLY CREATED WINDOW

	PUSH	[NEWHWND]
	CALL	UpdateWindow@4	; REDRAW THE VISIBLE PART OF THE WINDOW

MSG_LOOP:
	PUSH	0
	PUSH	0
	PUSH	0
	PUSH	OFFSET MSG
	CALL	GetMessageA@16

	CMP	EAX, 0
	JE	END_LOOP
	PUSH	OFFSET MSG
	CALL	TranslateMessage@4

	PUSH	OFFSET MSG
	CALL	DispatchMessageA@4

	JMP	MSG_LOOP
END_LOOP:
	PUSH	[MSG.MSWPARAM]
	CALL	ExitProcess@4

_ERR:
	JMP	END_LOOP

;----------------------------------------------------------------------------------------------
; Window Procedure
; Placement of parameters on the stack.
; [EBP+014h]	;LPARAM
; [EBP+10H]	;WPARAM
; [EBP+0CH]	;MES
; [EBP+8]	;HWND
WNDPROC	PROC
	PUSH	EBP
	MOV	EBP, ESP
	PUSH	EBX
	PUSH	ESI
	PUSH	EDI
	CMP	DWORD PTR [EBP+0CH], WM_DESTROY
	JE	WMDESTROY
	CMP	DWORD PTR [EBP+0CH], WM_CREATE
	JE	WMCREATE
	CMP	DWORD PTR [EBP+0CH], WM_PAINT
	JE	WMPAINT
	CMP	DWORD PTR [EBP+0CH], WM_LBUTTONDOWN
	JE	LBUTTON
	JMP	DEFWNDPROC
LBUTTON:
	CMP	P, 0
	JNE	F1
; LINE HORIZONTAL
	MOV	YP, 50	;Y
	MOV	XP, 10	;X
	MOV	ECX, 200
LL:
	PUSH	ECX
	PUSH	RGBP  ; red horizontal line
	PUSH	YP
	PUSH	XP
	PUSH	MEMDC
	CALL	SetPixelV@16
	INC	XP
	POP	ECX
	LOOP	LL
	INC	P
	JMP	F5
F1:
	CMP	P, 1
	JNE	F2
; SET THE CURRENT COORDINATES TO THE END OF THE PREVIOUS LINE
	PUSH	0
	PUSH	YP
	PUSH	XP
	PUSH	MEMDC
	CALL	MoveToEx@16
; LINE DRAWN BY A PEN
	PUSH	300
	PUSH	550
	PUSH	MEMDC
	CALL	LineTo@12
	INC	P
	JMP	F5
F2:
	CMP	P, 2
	JNE	F3
; CLOSED RECTANGLE
; SELECT A BRUSH FOR FILLING THE CLOSED AREA
	PUSH	HBRUSH
	PUSH	MEMDC
	CALL	SelectObject@8
; DRAW A FILLED RECTANGLE
; IF YOU DO NOT CHOOSE A BRUSH,
; THE RECTANGLE WILL NOT BE FILLED
	PUSH	350
	PUSH	400
	PUSH	200
	PUSH	200
	PUSH	MEMDC
	CALL	Rectangle@20
	INC	P
      JMP   F5
F3:
      CMP   P, 3
      JNE F4
; CHANGE BRUSH FOR ELLIPSE
      PUSH  0FFFF00h
      CALL  CreateSolidBrush@4
	PUSH	EAX
	PUSH	MEMDC
	CALL	SelectObject@8
; ELLIPSE ON SCREEN
      PUSH  100
      PUSH  500
      PUSH  50
      PUSH  450
      PUSH  MEMDC
      CALL  Ellipse@20
      PUSH  200
      PUSH  500
      PUSH  150
      PUSH  450
      PUSH  MEMDC
      CALL  Ellipse@20
      INC   P
      JMP   F5
F4:
      CMP   P, 4
      JNE   FIN ; CHANGE TO F5 if something else.
; IN ORDER TO LOAD IMAGE, MUST CREATE DC TO LOAD IMAGE TO
	PUSH	HDC
	CALL	CreateCompatibleDC@4
	MOV	MEMDC2, EAX
; Load Bitmap for display, using LoadImage() function
      PUSH  010h    ; LR_LOADFROMFILE   equ 10h
      PUSH  0
      PUSH  0
      PUSH  IMAGE_BITMAP
      PUSH  OFFSET HAPPY
      PUSH  MEMDC2
      CALL  LoadImageA@24
; SELECT BITMAP INTO NEW DC
	PUSH	EAX
	PUSH	MEMDC2
	CALL	SelectObject@8
; DOES THE FOLLOWING WORK BY PUTTING THE BITMAP ON THE SCREEN??? NO
      PUSH  0CC0020h    ;  SRCCOPY equ 0CC0020h
      PUSH  0
      PUSH  0
      PUSH  MEMDC2
      PUSH  100
      PUSH  100
      PUSH  100
      PUSH  100
      PUSH  MEMDC
      CALL  BitBlt@36      
; RELEASE NEWLY CREATED DC
	PUSH	MEMDC2
	PUSH	DWORD PTR [EBP+08H]
	CALL	ReleaseDC@8
      
F5:
; ISSUE A COMMAND TO REDRAW THE WINDOW
	PUSH	0
	PUSH	OFFSET RECT
	PUSH	DWORD PTR [EBP+08H]
	CALL	InvalidateRect@12
FIN:
	MOV	EAX, 0
	JMP	FINISH
WMPAINT:
	PUSH	OFFSET PNT
	PUSH	DWORD PTR [EBP+08H]
	CALL	BeginPaint@8
	MOV	HDC, EAX
; COPY THE VIRTUAL WINDOW TO THE REAL ONE
	PUSH	0CC0020H	; SRCCOPY = DISPLAY THE IMAGE AS IS
	PUSH	0		; Y - COORDINATE OF THE SOURCE
	PUSH	0		; X - COORDINATE OF THE SOURCE
	PUSH	MEMDC		; SOURCE CONTEXT
	PUSH	YM		; HEIGHT
	PUSH	XM		; WIDTH
	PUSH	0		; Y - WHERE
	PUSH	0		; X - WHERE
	PUSH	HDC		; CONTEXT - WHERE
	CALL	BitBlt@36
; CLOSE THE WINDOW CONTEXT
	PUSH	OFFSET PNT
	PUSH	DWORD PTR [EBP+08H]
	CALL	EndPaint@8
	MOV	EAX, 0
	JMP	FINISH
WMCREATE:
; SCREEN SIZE
	PUSH	0	; X
	CALL	GetSystemMetrics@4
	MOV	XM, EAX
	PUSH	1	; Y
	CALL	GetSystemMetrics@4
	MOV	YM, EAX
; OPEN THE WINDOW CONTEXT
	PUSH	DWORD PTR [EBP+08H]
	CALL	GetDC@4
	MOV	HDC, EAX
; CREATE THE DEVICE CONTEXT COMPATIBLE WITH THIS WINDOW
	PUSH	EAX
	CALL	CreateCompatibleDC@4
	MOV	MEMDC, EAX
; CREATE A BITMAP COMPATIBLE TO THE HDC CONTEXT IN MEMORY
	PUSH	YM
	PUSH	XM
	PUSH	HDC
	CALL	CreateCompatibleBitmap@12
; CHOOSE THE BITMAP IN THIS CONTEXT
	PUSH	EAX
	PUSH	MEMDC
	CALL	SelectObject@8
; BRUSH COLOR
	PUSH	RGBW
	CALL	CreateSolidBrush@4	; CREATE A BRUSH
; CHOOSE THE BRUSH IN THE GIVEN CONTEXT
	PUSH	EAX
	PUSH	MEMDC
	CALL	SelectObject@8
; FILL THE RECTANGULAR AREA
	PUSH	0F00021H	; PATCOPY = FILL WITH THE SPECIFIED COLOR
	PUSH	YM
	PUSH	XM
	PUSH	0
	PUSH	0
	PUSH	MEMDC
	CALL	PatBlt@24
; CREATE A PEN AND A BRUSH FOR DRAWING
	PUSH	RGBR
	CALL	CreateSolidBrush@4	; CREATE A BRUSH
      MOV   HBRUSH, EAX
; SPECIFY THE PEN
	PUSH	RGBR		; COLOR
	PUSH	0		; THICKNESS = 1
	PUSH	0		; SOLID LINE
	CALL	CreatePen@12
	MOV	HPEN, EAX
; DELETE THE CONTEXT
	PUSH	HDC
	PUSH	DWORD PTR [EBP+08H]
	CALL	ReleaseDC@8
	MOV	EAX, 0
	JMP	FINISH
DEFWNDPROC:
	PUSH	DWORD PTR [EBP+14H]
	PUSH	DWORD PTR [EBP+10H]
	PUSH	DWORD PTR [EBP+0CH]
	PUSH	DWORD PTR [EBP+08H]
	CALL	DefWindowProcA@16
	JMP	FINISH
WMDESTROY:
; DELETE THE PEN
	PUSH	HPEN
	CALL	DeleteDC@4
; DELETE THE BRUSH
	PUSH	HBRUSH
	CALL	DeleteDC@4
; DELETE THE VIRTUAL WINDOW
	PUSH	MEMDC
	CALL	DeleteDC@4
; EXIT
	PUSH	0
	CALL	PostQuitMessage@4	; WM_QUIT
	MOV	EAX, 0
FINISH:
	POP EDI
	POP ESI
	POP EBX
	POP EBP
	RET 16
WNDPROC	ENDP
;----------------------------------------------------------------------------------------------

_TEXT ENDS
END START

